/************************************************************
*                                                           *
* Politecnico di Milano - University of Illinois at Chicago *
*                                                           *
*    Networked Operating Systems exam - Professor Piuri     *
*                                                           *
* Assignment by Daniele Paolo Scarpazza                     *
* Copyright (C) 2000, by Daniele Paolo Scarpazza.           *
*               All rights reserved.                        *
*                                                           *
************************************************************/

/*
  Note to code maintainers:

  WARNING: this program listing contains embedded documentation.
  Please respect writing conventions, otherwise modifications could
  result in inconsistent or partially missing generated documentation. 

  Daniele Paolo Scarpazza

*/

#define  DEFAULT_REGISTRATION_NAME  "mailbox"


#include <sys/types.h>
#include <sys/socket.h>
#include <sys/unistd.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <netdb.h>
#include <errno.h>
#include "termgraph.h"
#include "remotemailbox.h"

/** Reader test program's main() function.
    This function connects to a user-specified host, on which the 
    mailboxd daemon should be up and running,  
    and tries to register a test mailbox
    called "mailbox", reporting possible errors.
    The server hostname can be specified as the first parameter on the 
    command line.
*/

int main(int argc, char** argv)
{
 CRemoteMailbox rmbx;
 char *             strHostName;
 char               rc;
 unsigned char      chLen;
 char               strIdentifier [RMBX_MAILBOX_ID_SIZE+1],
                    strSenderName [RMBX_MAILBOX_ID_SIZE+1],
                    strMessageBody[RMBX_MAX_MESSAGE_SIZE+1];
 int                iSenderLen,iMsgLen,iResult;

 printmsg("Starting mailbox reader test client"); OK;

 printf("Please enter the reader's identifier (press enter for default): "); 
 fflush(NULL);
 gets(strIdentifier);
  
 if (strlen(strIdentifier)==0)
   {
     puts("No identifier specified, using default =  " DEFAULT_REGISTRATION_NAME);
     strcpy(strIdentifier,DEFAULT_REGISTRATION_NAME);
   }
 
 if (argc==1)
   {
     puts("No server host specified, using localhost...");  
     rmbx.Connect(strIdentifier);
   } else rmbx.Connect(strIdentifier,argv[1]);

 
 while(true)
 { 
   iSenderLen = RMBX_MAILBOX_ID_SIZE;
   iMsgLen    = RMBX_MAX_MESSAGE_SIZE;
   if (!rmbx.ReceiveMessage(strSenderName, &iSenderLen,strMessageBody, &iMsgLen)) 
     break;
 }  
 puts("Quitting.");
}











