/************************************************************
*                                                           *
* Politecnico di Milano - University of Illinois at Chicago *
*                                                           *
*    Networked Operating Systems exam - Professor Piuri     *
*                                                           *
* Assignment by Daniele Paolo Scarpazza                     *
* Copyright (C) 2000, by Daniele Paolo Scarpazza.           *
*               All rights reserved.                        *
*                                                           *
************************************************************/

/*
  Note to code maintainers:

  WARNING: this program listing contains embedded documentation.
  Please respect writing conventions, otherwise modifications could
  result in inconsistent or partially missing generated documentation. 

  Daniele Paolo Scarpazza

*/

#define    MOVE_TO_COL      "\033[60G"
#define    MOVE_TO_COL_ZERO "\033[0G"
#define    SETCOLOR_SUCCESS "\033[1;32m"
#define    SETCOLOR_FAILURE "\033[1;31m"
#define    SETCOLOR_WARNING "\033[1;33m"
#define    SETCOLOR_NORMAL  "\033[0;39m"

#define    OK   {printf(MOVE_TO_COL"[  "SETCOLOR_SUCCESS"OK"SETCOLOR_NORMAL"  ]\r\n");   }

#define    FAIL {printf(MOVE_TO_COL"["SETCOLOR_FAILURE"FAILED"SETCOLOR_NORMAL"]\r\n");  /*printf("errno = %i",errno);*/  exit(EXIT_FAILURE); }

#define    FAIL_NE {printf(MOVE_TO_COL"["SETCOLOR_FAILURE"FAILED"SETCOLOR_NORMAL"]");  fflush(0);}

#define    WAIT {printf(MOVE_TO_COL"[ "SETCOLOR_WARNING"WAIT"SETCOLOR_NORMAL" ]"); fflush(0); }
#define    printmsg(x) printf( x MOVE_TO_COL "[      ]");

//verbosity-dependent functions

#define    VOK   							     \
{									     \
  if (m_bVerbose) 							     \
    printf(MOVE_TO_COL"[  "SETCOLOR_SUCCESS"OK"SETCOLOR_NORMAL"  ]\r\n");    \
}

#define    VFAIL(instr) 						     \
{									     \
 if (m_bVerbose)							     \
   { 									     \
     printf(MOVE_TO_COL"["SETCOLOR_FAILURE"FAILED"SETCOLOR_NORMAL"]\r\n");   \
     /*printf("errno = %i",errno);*/  					     \
     instr; 						                     \
   }									     \
}


#define    VFAIL_NE							\
{									\
 if (m_bVerbose)							\
 printf(MOVE_TO_COL"["SETCOLOR_FAILURE"FAILED"SETCOLOR_NORMAL"]\r\n");	\
}

#define    VWAIT							\
{									\
 if (m_bVerbose)							\
   {									\
     printf(MOVE_TO_COL"[ "SETCOLOR_WARNING"WAIT"SETCOLOR_NORMAL" ]");	\
     fflush(0);								\
   }									\
}

#define    vprintmsg(x) 			\
{						\
  if (m_bVerbose) 				\
    printf(x MOVE_TO_COL"[      ]");		\
}
