/************************************************************
*                                                           *
* Politecnico di Milano - University of Illinois at Chicago *
*                                                           *
*    Networked Operating Systems exam - Professor Piuri     *
*                                                           *
* Assignment by Daniele Paolo Scarpazza                     *
* Copyright (C) 2000, by Daniele Paolo Scarpazza.           *
*               All rights reserved.                        *
*                                                           *
************************************************************/

/*
  Note to code maintainers:

  WARNING: this program listing contains embedded documentation.
  Please respect writing conventions, otherwise modifications could
  result in inconsistent or partially missing generated documentation. 

  Daniele Paolo Scarpazza

*/

#define DEFAULT_REGISTRATION_NAME  "writer"
#define DEFAULT_MESSAGE_TEXT       "This is an example test message."

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/unistd.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>
#include <netdb.h>
#include <errno.h>
#include "termgraph.h"
#include "remotemailbox.h"

/** Writer test program's main() function.
  *  This function connects to a user-specified host, on which the 
  *  mailboxd daemon should be up and running,  
  *  and tries to send a message to a test mailbox
  *  called "mailbox", reporting possible errors.
  *  The server hostname can be specified as the first parameter on the 
  *  command line.
  */

int main(int argc, char** argv)
{
  CRemoteMailbox rmbx;
  char *             
    strHostName, 
    strDestination[RMBX_MAILBOX_ID_SIZE+1],
    strIdentifier [RMBX_MAILBOX_ID_SIZE+1],
    strMsgBody    [RMBX_MAX_MESSAGE_SIZE+1];
 
  printmsg("Starting mailbox writer test client"); OK;

  printf("Please enter the writer's identifier (press enter for default): "); 
  fflush(NULL);
  gets(strIdentifier);
  
  if (strlen(strIdentifier)==0)
    {
      puts("No identifier specified, using default =  " DEFAULT_REGISTRATION_NAME);
      strcpy(strIdentifier,DEFAULT_REGISTRATION_NAME);
    }

  if (argc==1)
    {
      puts("No server host specified, using localhost...");  
      if (!rmbx.Connect(strIdentifier)) return EXIT_FAILURE;
    } else if (!rmbx.Connect(strIdentifier,argv[1])) return EXIT_FAILURE;

  while (true)
    {
      printf("Please enter the message's recipient (press enter to broadcast): "); fflush(NULL);
      gets(strDestination);

      printf("Please enter the message text (press enter for test message): "); fflush(NULL);
      gets(strMsgBody);

      if (!strlen(strMsgBody))
	{
	  strcpy(strMsgBody,DEFAULT_MESSAGE_TEXT);
	  puts("No message text specified, using default test message.");
	}

      if (strlen(strDestination))
	rmbx.SendMessage(strDestination, strMsgBody, strlen(strMsgBody));
      else
	rmbx.BroadcastMessage(strMsgBody, strlen(strMsgBody));
      puts("Press enter to continue, ^C to exit gracefully...");
      getchar();
    }
}















